import 'package:bitcoin_flutter/bitcoin_flutter.dart';

class BitcoinIn {
  String txHash;
  int vout;
}

class BitcoinOut {
  String address;
  int value;
}

class BitcoinTransaction {
  static Future<String> signBitcoinTransaction(
      String privateKey, Transaction transaction) async {
    try {
      ECPair ecPair = ECPair.fromWIF(privateKey);
      TransactionBuilder transactionBuilder =
          TransactionBuilder.fromTransaction(transaction);
      transactionBuilder.inputs.forEach((element) {
        int index = transactionBuilder.inputs.indexOf(element);
        transactionBuilder.sign(vin: index, keyPair: ecPair);
      });
      String hex = transaction.toHex();
      return hex;
    } catch (e) {
      print('_signBitcoinTransaction error : $e');
    }
    return null;
  }

  static Future<String> createBitcoinTransaction(
      List ins, List outs, int fee) async {
    return null;
  }

  static Future<String> createOmniTransaction(List<BitcoinIn> ins,
      List<BitcoinOut> outs, int fee, int value, int contract) async {
    final txb = new TransactionBuilder();
    ins.forEach((element) {
      txb.addInput(element.txHash, element.vout);
    });
    outs.forEach((element) {
      txb.addOutput(element.address, element.value);
    });

    return null;
  }
}
